const _ = require('lodash');
const nodemailer = require('nodemailer');
const hbs = require('nodemailer-express-handlebars');

const path = require('path');

const defaults = {
  from: '"Dummy User" <dummy.job.test@gmail.com>'
}

const defaultContext = {
  companyName: 'Job-System',
  headerImage: 'http://via.placeholder.com/350x150'
}

const transporter = nodemailer.createTransport({
  host: 'smtp.gmail.com',
  port: '587',
  auth: {
    user: 'dummy.job.test@gmail.com',
    pass: 'Dummy1234'
  },
  tls: {
    rejectUnauthorized: false
  }
});

transporter.use('compile', hbs({
  viewPath: './src/mailers',
  extName: '.hbs'
}));

function sendEmail(from, to, subject, templateName, context = {}) {
  let template = {
    form: from || defaults.from,
    to: to,
    subject: subject,
    template: templateName,
    context: _.extend({}, defaultContext, context)
  };

  transporter.sendMail(template, (error, info) => {
    if (error) {
      return console.log(error);
    }
    console.log('email was send');
  });
}

module.exports = {
  sendEmail: sendEmail
};
