function requestParser(req, res, next) {
  next();
}

function responseParser(req, res, next) {
  res.status(200).json(res.locals.data);
}

function errorHandler(err, req, res, next) {
  if (res.headersSent) {
    return next(err);
  }
  res.status(500).send({ error: err.message });
}

module.exports = {
  requestParser: requestParser,
  responseParser: responseParser,
  errorHandler: errorHandler
}